# Packages required to execute DSH
default['dsh']['packages'] = {
  'dsh' => {}
}

# System defaults
default['dsh']['config_path'] = '/etc/dsh.conf'
default['dsh']['group_dir'] = '/etc/dsh/group'

# Configuration for DSH
default['dsh']['config'] = {
  'remoteshell' => 'ssh',
  'showmachinenames' => 1 # Make -M a default
}

# N.B. The mappings below are executed in the order they appear

# Set a user for DSH hosts
default['dsh']['mappings']['user_name'] = nil

# Shim to override user for DSH hosts in given groups
# N.B. Executed before prefixes and suffixes, after aggregates are added
default['dsh']['mappings']['shim_user_name'] = {
  # 'test' => 'vagrant'
}

# Node field for DSH hosts (e.g. "name", "ipaddress")
default['dsh']['mappings']['host_field'] = 'hostname'

# Which environments to consider (env -> boolean|group)
# N.B. If the environment is mapped to a group name rather than a boolean,
#      the group name will be used over the environment name
default['dsh']['mappings']['environments'] = {
  # 'test' => true
}

# Map partial node names to DSH groups (name -> group)
# N.B. Each partial is converted to a Regexp before evaluation. This Regexp
#      is case-insensitive and wraps the partial with a non-word boundary
default['dsh']['mappings']['names'] = {
  # 'test' => 'test'
}

# Map partial role names to DSH group names (role -> group)
# N.B. Each partial is converted to a Regexp before evaluation. This Regexp
#      is case-insensitive and wraps the partial with a non-word boundary
default['dsh']['mappings']['roles'] = {
  # 'some' => 'other'
}

# Map tags to DSH group names (tag -> boolean|group)
# N.B. If the tag is mapped to a group name rather than a boolean, the group
#      name will be used over the tag
default['dsh']['mappings']['tags'] = {
  # 'some_tag' => true
}

# Aggregate DSH groups into larger collections (group -> [group])
# N.B. Executed before prefixes and suffixes are added
default['dsh']['mappings']['aggregates'] = {
  # 'supergroup' => %w[ test other ]
}

# Exclude nodes with certain groups from appearing in DSH at all
default['dsh']['mappings']['excludes'] = {
  # 'offline' => true
}

# Like suffixes, but without replacing (group -> prefix)
# N.B. Does not add the suffix to the indicated group!
default['dsh']['mappings']['suffixes'] = {
  # 'test' => '-test'
}

# Like prefixes, but without replacing (group -> prefix)
# N.B. Does not add the prefix to the indicated group!
default['dsh']['mappings']['prefixes'] = {
  # 'test' => 'test-'
}

# Add suffixes to nodes with the specified groups (group -> suffix)
# N.B. Does not add the suffix to the indicated group!
default['dsh']['mappings']['suffixes!'] = {
  # 'test' => '-test'
}

# Add prefixes to nodes with the specified groups (group -> prefix)
# N.B. Does not add the prefix to the indicated group!
default['dsh']['mappings']['prefixes!'] = {
  # 'test' => 'test-'
}